com.io7m.jpra.model.type_expressions

## Class TypeExprVector<I,T>

- java.lang.Object
- - com.io7m.jpra.model.type_expressions.TypeExprVector<I,T>

- Type Parameters:
    `I` - The type of identifiers
    `T` - The type of evaluated types
  All Implemented Interfaces:
    ModelElementType, TypeExprType<I,T>

      public final class TypeExprVector<I,T>
      extends Object
      implements TypeExprType<I,T>

  A `vector` type expression.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TypeExprVector(T in_type, Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>> in_lex, SizeExprType<I,T> in_element_count, TypeExprType<I,T> in_element_type)` Construct an expression.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SizeExprType<I,T>` | `getElementCount()`
    `TypeExprType<I,T>` | `getElementType()`
    `Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>>` | `getLexicalInformation()` Fetch the lexical information for the element.
    `T` | `getType()`
    `<A,E extends Exception> A` | `matchType(TypeExprMatcherType<I,T,A,E> m)` Accept a matcher.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TypeExprVector

          public TypeExprVector(T in_type,
                                Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>> in_lex,
                                SizeExprType<I,T> in_element_count,
                                TypeExprType<I,T> in_element_type)

      Construct an expression.
      Parameters:
        `in_type` - The expression type
        `in_lex` - Lexical information
        `in_element_count` - The number of elements
        `in_element_type` - The type of elements

  - ### Method Detail

    - #### matchType

          public <A,E extends Exception> A matchType(TypeExprMatcherType<I,T,A,E> m)
                                              throws E extends Exception

      Description copied from interface: `TypeExprType`
      Accept a matcher.
      Specified by:
        `matchType` in interface `TypeExprType<I,T>`
      Type Parameters:
        `A` - The type of returned values
        `E` - The type of raised exceptions
      Parameters:
        `m` - The matcher
      Returns:
        The value returned by `m`
      Throws:
        `E` - If `m` raises `E`
        `E extends Exception`

    - #### getType

          public T getType()

      Specified by:
        `getType` in interface `TypeExprType<I,T>`
      Returns:
        The assigned expression type

    - #### getLexicalInformation

          public Optional<com.io7m.jlexing.core.ImmutableLexicalPositionType<Path>> getLexicalInformation()

      Description copied from interface: `ModelElementType`
      Fetch the lexical information for the element. This is used to localize error messages to a position in a file when referring to specific elements.
      Specified by:
        `getLexicalInformation` in interface `ModelElementType`
      Returns:
        The original lexical information, if any

    - #### getElementCount

          public SizeExprType<I,T> getElementCount()

      Returns:
        A size expression denoting the number of elements

    - #### getElementType

          public TypeExprType<I,T> getElementType()

      Returns:
        A type expression denoting the type of elements

Copyright © 2016 <code@io7m.com> http://io7m.com